import 'package:carg/const.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:flutter_gen/gen_l10n/app_localizations.dart';
import 'package:flutter_svg/svg.dart';

class SplashScreen extends StatelessWidget {
  const SplashScreen({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return AnnotatedRegion<SystemUiOverlayStyle>(
      value: SystemUiOverlayStyle.dark,
      child: Scaffold(
          body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            SizedBox(
              height: 60,
              width: 60,
              child: SvgPicture.asset(Const.svgLogoPath),
            ),
            Padding(
              padding: const EdgeInsets.all(8.0),
              child: Text(
                '${AppLocalizations.of(context)!.startup}...',
                style: const TextStyle(fontWeight: FontWeight.bold),
              ),
            ),
            const SizedBox(
                height: 30,
                width: 30,
                child: CircularProgressIndicator(
                  strokeWidth: 8,
                ))
          ],
        ),
      )),
    );
  }
}
